// FILENAME:  Starsiege_Hockey.cs
//
// AUTHORS:   Orogogus, Kore
// COMMENTS TO:  h2liu@iname.com
// LAST UPDATED: 4:27 PM 2/13/00
// WEBSITE:  http://home.san.rr.com/orogogus/scripts.html#hockey
//
//------------------------------------------------------------------------------

$missionName = "Starsiege Hockey";
$nameOfTheGame = "Hockey";

exec("multiplayerStdLib.cs");

$server::HudMapViewOffsetX = -8000;
$server::HudMapViewOffsetY = -8000;



function setDefaultMissionOptions()
{
  $server::TeamPlay = true;
  $server::AllowDeathmatch = false;
  $server::AllowTeamPlay = true;  

   // what can the client choose for a team
  $server::AllowTeamRed = true;
  $server::AllowTeamBlue = true;
  $server::AllowTeamYellow = false;
  $server::AllowTeamPurple = false;

  // what can the server admin choose for available teams
  $server::disableTeamRed = false;
  $server::disableTeamBlue = false;
  $server::disableTeamYellow = true;
  $server::disableTeamPurple = true;
}

function setDefaultMissionItems() 
{
  exec("defaultVehicles");
  allowComponent("all", true);
  allowWeapon("all", true);
}

function onMissionStart()
{
}


function onMissionLoad()
{
  $scoreLimit = 5;
  $redScore = 0;
  $blueScore = 0;
  $startPenalty = 15;

  $vectorModifier = 1;
  $gradInterval = 0.01;
  $movesPerHit = 100;

  $Puck = getObjectId("MissionGroup/Puck/Puck");
  $Puck.startX = getPosition($Puck, x);
  $Puck.startY = getPosition($Puck, y);
  $Puck.startZ = getPosition($Puck, z);

  $Puck.counter = 0;
  $Puck.carrier = 0;
  $Puck.shotNumber = 0;
  $Puck.vectorX = 0;
  $Puck.vectorY = 0;

  $starterA = 0;
  $starterB = 0;
  $starterACount = 0;
  $starterBCount = 0;
  $hockeyState = 0;
  $practiceState = 0;

  for(%i = 1; %i < 11; %i++)
  {
    $starter[%i] = getObjectId("MissionGroup/Starters/" @ %i);
    %temp = getPosition($starter[%i], rot);
    $starter[%i].rot = %temp * 180 / 3.14159;
  }


  %nowDate = getDate();
  %nowTime = getTime();
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ "server start";
  fileWrite("multiplayer\\serverlog.txt", append, %outputString);

  $startTime = getCurrentTime();
}


//======================  starting routines


function starterA::trigger::OnEnter(%this, %vehicleId)
{
  if($hockeyState == 1) return;

  %count = playerManager::getPlayerCount();
  if(%count == 1)
  {
    $hockeyState = 1;
    $practiceState = 1;
    say("everyone", 0, "Single player practice mode beginning");
    setHudTimerAll(8, -1, "Time to start", 1);
    schedule("startHockey();", 8);
    dropPuck();
    return;
  }

  $starterACount++;
  if($starterACount == 1) say("everyone", 0, "Red Team is ready");
  $starterA = 1;

  if($starterB == 1)
  {
    $hockeyState = 1;
    say("everyone", 0, "Round begins in 8 seconds!");
    setHudTimerAll(8, -1, "Time to start", 1);
    schedule("startHockey();", 8);
    dropPuck();
  }
}

function starterB::trigger::OnEnter(%this, %vehicleId)
{
  if($hockeyState == 1) return;

  %count = playerManager::getPlayerCount();
  if(%count == 1)
  {
    $hockeyState = 1;
    $practiceState = 1;
    say("everyone", 0, "Single player practice mode beginning");
    setHudTimerAll(8, -1, "Time to start", 1);
    schedule("startHockey();", 8);
    dropPuck();
    return;
  }

  $starterBCount++;
  if($starterBCount == 1) say("everyone", 0, "Blue Team is ready");
  $starterB = 1;

  if($starterA == 1)
  {
    $hockeyState = 1;
    say("everyone", 0, "Round begins in 8 seconds!");
    setHudTimerAll(8, -1, "Time to start", 1);
    schedule("startHockey();", 8);
    dropPuck();
  }
}

function starterA::trigger::OnLeave(%this, %vehicleId)
{
  if($hockeyState == 1) return;

  $starterACount--;
  if($starterACount == 0)
  {
    say("everyone", 0, "Red team is taking more time to prepare");
    $starterA = 0;
  }
}

function starterB::trigger::OnLeave(%this, %vehicleId)
{
  if($hockeyState == 1) return;

  $starterBCount--;
  if($starterBCount == 0) 
  {
    say("everyone", 0, "Blue team is taking more time to prepare");
    $starterB = 0;
  }
}


function startHockey()
{
  getNextObject(getObjectId("MissionGroup/Starters"), 0);
  liftUpStarters();

  %count = playerManager::getPlayerCount();
  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    setVehicleRadarVisible(%player.vehicleId, true);
  }
}


function liftUpStarters()
{
  for(%i = 1; %i < 11; %i++)
  {
    %x = getPosition($starter[%i], x);
    %y = getPosition($starter[%i], y);
    %z = getPosition($starter[%i], z) + 8000;
    setPosition($starter[%i], %x, %y, %z);
  }
}

function sendDownStarters()
{
  for(%i = 1; %i < 11; %i++)
  {
    %x = getPosition($starter[%i], x);
    %y = getPosition($starter[%i], y);
    %z = getPosition($starter[%i], z) - 8000;
    setPosition($starter[%i], %x, %y, %z, $starter[%i].rot);
  }
}


function dropPuck()
{
  dropPod(0, 590, 100, $Puck); 
//  dropPod(0, 590, 95, $Puck); 
}


//===============================  Player functions


function player::onAdd(%player)
{
  %player.startTime = getCurrentTime();
  %player.name = getName(%player);
  %nowDate = getDate();
  %nowTime = getTime();
  %player.IP = getConnection(%player);
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ %player.name @ " joined the game (" @ %player.IP @ ")";
  fileWrite("multiplayer\\serverlog.txt", append, %outputString);

  %player.goals = 0;

  if($hockeyState != 1) return;
  else
  {
    %player.state = 0;
    schedule("allowPlayer(" @ %player @ ");", $startPenalty);
  }
}

function player::OnRemove(%player)
{
  %player.name = getName(%player);
  %nowDate = getDate();
  %nowTime = getTime();
  %timeEnd = getCurrentTime();
  %timeIn = timeDifference( %timeEnd, %player.startTime);
  %outputString =  %nowDate @ ", " @ %nowTime @ " -- " @ %player.name @ " left the game (" @ %player.IP @ ") -- " @ %timeIn;

  fileWrite("multiplayer\\serverlog.txt", append, %outputString);

  %count = playerManager::getPlayerCount();
  if(%count == 0) missionEndConditionMet();
}


function allowPlayer(%player)
{
  if(%player.state == 1) return;
  %player.state = 1;
  say(%player, 0, "You may enter the game now");
}


function vehicle::onAdd(%vehicle)
{
  %player = playerManager::vehicleIdToPlayerNum(%vehicle);

  if($hockeyState != 1) %player.state = 1;
  if($hockeyState == 0) setVehicleRadarVisible(%vehicle, false);
  if(%player.state == 0)
  {
     schedule("healObject(" @ %vehicle @ ", -50000);", 1);
     say(%player, 0, "Sorry -- there is a " @ $startPenalty @ " second penalty before you can (re)join a game in progress");
     return;
  }

  %vehicle.name = %player.name;
  %player.vehicle = getVehicleName(%vehicle);
  %player.vehicleId = %vehicle;
  %vehicle.team = getTeam(%vehicle);

  if($hockeyState == 1) say("everyone", 0, %player.name @ " is on the field");
}


function vehicle::onDestroyed(%destroyed, %destroyer)
{
  %player = playerManager::vehicleIdToPlayerNum(%destroyed);

  if(%player.state == 1)
  {
    %player.state = 0;
    schedule("allowPlayer(" @ %player @ ");", $startPenalty);
  }

  %message = getFancyDeathMessage(getHUDName(%destroyed), getHUDName(%destroyer));
  if(%destroyer == %destroyed) return;
  if(%message != "")
  {
     say( 0, 0, %message);
  }

  if(%destroyed == $Puck.carrier)
  {
     say("everyone", 0, %destroyer.name @ " steals the puck!");
  }
}


function setHudTimerAll(%time, %increment, %string, %channel)
{
  %count = playerManager::getPlayerCount();
  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    setHudTimer(%time, %increment, %string, %channel, %player);
  }
}


//===============================  Puck functions


function puck::structure::OnAttacked(%target, %attacker)
{
  if($hockeyState == 2) return;
  if(%target.ignoreShots > 1) return;

  %player = playerManager::vehicleIdToPlayerNum(%attacker);

  if(%attacker != %target.carrier)
  {
    say("everyone", 0, %player.name @ " has the puck");

    %target.carrier = %attacker;
  }

  %tPosX = getPosition(%target, x);
  %tPosY = getPosition(%target, y);
  %aPosX = getPosition(%attacker, x);
  %aPosY = getPosition(%attacker, y);

  %newDirX = %tPosX - %aPosX ;
  %newDirY = %tPosY - %aPosY;

  %howFar = getDistance(%target, %attacker);

  %target.vectorX = %newDirX / %howFar;
  %target.vectorY = %newDirY / %howFar;

  %target.shotNumber++;
  %striker = %target.shotNumber;

  %target.counter = $movesPerHit;

  gradMove(%target, %striker);
}


function gradMove(%target, %striker)
{
  if(%striker != %target.shotNumber) return;
  if($hockeyState == 2) return;

  %tPosX = getPosition(%target, x);
  %tPosY = getPosition(%target, y);

  %newTPosX = $vectorModifier * (%tPosX + %target.vectorX);
  %newTPosY = $vectorModifier * (%tPosY + %target.vectorY);
  %newTPosZ = getTerrainHeight(%newTPosX, %newTPosY);
//  %newTPosZ = getTerrainHeight(%newTPosX, %newTPosY) - 5;
  setPosition(%target, %newTPosX, %newTPosY, %newTPosZ);

  checkPos(%target);

  %target.counter--;
  if(%target.ignoreShots > 1) %target.ignoreShots--;
  if(%target.counter <= 0) return;
  schedule("gradMove(" @ %target @ ", " @ %striker @ ");", $gradInterval);
}


function checkPos(%target)
{
  if($hockeyState == 2) return;

  %tPosX = getPosition(%target, x);
  %tPosY = getPosition(%target, y);

  if((%tPosX <= -832 && %target.vectorX < 0)  // covers the left and right
   || (%tPosX >= 832 && %target.vectorX > 0))
  {
    %target.vectorX = %target.vectorX * -1;
    %target.ignoreShots = 300;
    %target.counter = 300;
  }

  if(%tPosY <= -736)
  {
    if(%tPosX < 200 && %tPosX > -200)
    {
      scoreRed();
    }
    else if(%target.vectorY < 0)
    {
      %target.vectorY = %target.vectorY * -1;
      %target.ignoreShots = 300;
      %target.counter = 300;    // rebound distance
    }
  }

  if(%tPosY >= 1920)
  {
    if(%tPosX < 200 && %tPosX > -200)
    {
       scoreBlue();
    }
    else if(%target.vectorY > 0)
    {
      %target.vectorY = %target.vectorY * -1;
      %target.ignoreShots = 300;
      %target.counter = 300;   // rebound distance
    }
  }
}


//==========================   Scoring, reset rounds


function scoreBlue()
{
   if($practiceState == 1)
   {
     $hockeyState = 2;
     $practiceState = 0;
     say("everyone", 0, "Goal scored -- no points awarded in practice mode");
     resetEveryone();
     return;
   }

   $hockeyState = 2;
   $blueScore++;
   
   if($blueScore >= $scoreLimit)
   {
     say("everyone", 0, "The blue team has won the game!");
     schedule("missionEndConditionMet();", 5);
   }
   else
   {
     say("everyone", 0, "The blue team has scored a goal!");
     %temp = $scoreLimit - $blueScore;
     say("everyone", 0, %temp @ " more to win.");
     resetEveryone();
   }
}


function scoreRed()
{
   if($practiceState == 1)
   {
     $hockeyState = 2;
     $practiceState = 0;
     say("everyone", 0, "Goal scored -- no points awarded in practice mode");
     resetEveryone();
     return;
   }

   $hockeyState = 2;
   $redScore++;

   if($redScore >= $scoreLimit)
   {
     say("everyone", 0, "The red team has won the game!");
     schedule("missionEndConditionMet();", 5);
   }
   else
   {
     say("everyone", 0, "The red team has scored a goal!");
     %temp = $scoreLimit - $redScore;
     say("everyone", 0, %temp @ " more to win.");
     resetEveryone();
   }
}


function resetEveryone()
{
  $hockeyState = 0;
  resetPuck();

  $starterA = 0;
  $starterB = 0;
  $starterACount = 0;
  $starterBCount = 0;

  sendDownStarters();

  %count = playerManager::getPlayerCount();
  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);

    if(%player.state == 0)
    {
      %player.state = 1;
      say(%player, 0, "You may join the game now");
    }
    else
    {
      %playerVeh = playerManager::playerNumToVehicleId(%player);
      fadeEvent(%player, out, 1.0, 1.0, 1.0, 1.0);
      healObject(%playerVeh, 50000);
      healObject(%playerVeh, 50000);
      healObject(%playerVeh, 50000);
      reloadObject(%playerVeh, 100);
      setVehicleRadarVisible(%playerVeh, false);
      redrop(%playerVeh);
      fadeEvent(%player, in, 1.0, 1.0, 1.0, 1.0);
    }
  }
}


function resetPuck()
{
  $Puck.ignoreShots = 0;
  $Puck.counter = 0;
  $Puck.carrier = 0;
  $Puck.shotNumber = 0;
  $Puck.vectorX = 0;
  $Puck.vectorY = 0;

  setPosition($Puck, $Puck.startX, $Puck.startY, $Puck.startZ);
}


//==========================   Misc, boundary functions


function OutOfBounds::trigger::onEnter(%this, %vehicleId)
{
    %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
    say("everyone", 0, %player.name @ " was killed for going out of bounds");
    healObject(%vehicleId, -50000);
}


function RedGoal::trigger::onEnter(%this, %vehicleId)
{
    %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
    say("everyone", 0, %player.name @ " was killed for going out of bounds");
    healObject(%vehicleId, -50000);
}


function BlueGoal::trigger::onEnter(%this, %vehicleId)
{
    %player = playerManager::vehicleIdToPlayerNum(%vehicleId);
    say("everyone", 0, %player.name @ " was killed for going out of bounds");
    healObject(%vehicleId, -50000);
}


//========================  Scoreboard


function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");

  // Player ScoreBoard column headings
  $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_TEAM;
  $ScoreBoard::PlayerColumnHeader3 = *IDMULT_SCORE_SCORE;
  $ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_KILLS;
  $ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_DEATHS;

  // Player ScoreBoard column functions
  $ScoreBoard::PlayerColumnFunction1 = "getTeam";
  $ScoreBoard::PlayerColumnFunction3 = "getPlayerScore";
  $ScoreBoard::PlayerColumnFunction4 = "getKills";
  $ScoreBoard::PlayerColumnFunction5 = "getDeaths";

   // Team ScoreBoard column headings
   $ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_SCORE;
   $ScoreBoard::TeamColumnHeader2 = *IDMULT_SCORE_PLAYERS;
   $ScoreBoard::TeamColumnHeader3 = *IDMULT_SCORE_KILLS;
   $ScoreBoard::TeamColumnHeader4 = *IDMULT_SCORE_DEATHS;

   // Team ScoreBoard column functions
   $ScoreBoard::TeamColumnFunction1 = "getTeamScore";
   $ScoreBoard::TeamColumnFunction2 = "getNumberOfPlayersOnTeam";
   $ScoreBoard::TeamColumnFunction3 = "getTeamKills";
   $ScoreBoard::TeamColumnFunction4 = "getTeamDeaths";

   // tell server to process all the scoreboard definitions defined above
   serverInitScoreBoard();
}



function getTeamScore(%team)
{
	%team = getTeamNameFromTeamId(%team);
	if(%team == *IDSTR_TEAM_PURPLE) 
	{
		return($purpleScore);
	}
	if(%team == *IDSTR_TEAM_YELLOW) 
	{
		return($yellowScore);
	}
	if(%team == *IDSTR_TEAM_RED) 
	{
		return($redScore);
	}
	if(%team == *IDSTR_TEAM_BLUE) 
	{
		return($blueScore);
	}

	return 0;
} 
